
open Translation

let rec f (t : Typeinf.t) =
  match t with
    (pre, typ) -> f_pre pre
and f_pre = function
    Typeinf.String x -> Typeinf.String x
  | Typeinf.Int x -> Typeinf.Int x
  | Typeinf.True -> Typeinf.True
  | Typeinf.False -> Typeinf.False
  | Typeinf.Attribute attr ->
      Typeinf.Attrriute (List.map (fun (x,t) -> (x, f t)) attr)
