
let rec bottles = fun n ->
  if n = 1 then
    PC "1 bottle"
  else
    (pc_of_int n) ^ (PC " bottles")
in
let rec verse = fun n ->
  if n = 0 then
    PC "0 bottles of beer on the wall,\n0 bottles of beer!\nGo into town, buy a new round\nGet some more bottles of beer on the wall!\n"
  else
    (bottles n)
    ^ (PC " of beer!\nTake on down, pass it around;\n") 
    ^ (bottles (n - 1))
    ^ (PC " of beer on the wall.\n") 
    ^ (verse (n - 1))
in
let rec main_sub2 = fun t ->
  match t with
      PC x -> verse (int_of_string x)
    | _ -> PC ""
in
let rec main_sub = fun x ->
  match x with
      hd::_ -> main_sub2 hd (* verse (int_of_string x) *)
    | [] -> PC ""
in
let rec main = fun t ->
  match t with
      t1 ->
	begin
	  match t1 with
	      <bottles>@_$x -> main_sub x
	    | t -> t
	    | PC x -> PC x
	end
    | PC x -> PC x
in
  main
