
(* let get_id = fun t -> match t with <id>@_[x::[]] -> match x with PC x -> x in *)
let rec scan_pc = fun buf -> fun l -> 
  match l with 
      hd::tl ->
	begin
	  match hd with PC x -> scan_pc x tl | _ -> scan_pc buf tl
	end
    | [] -> buf
in
let get_id = fun t -> match t with <id>@_$l -> scan_pc "" l in
let get_firstname = fun t -> match t with <firstname>@_$l -> scan_pc "" l in
let rec get_firstname_from_list = fun tl ->
  match tl with
      hd::tl ->
	(match hd with 
	     <firstname>@_$x -> (match x with hd :: [] -> hd)
	   | _ -> get_firstname_from_list tl)
  | [] -> PC ""
in
let get_firstname_buf = fun t ->
  match t with
      <row>@_$tl -> get_firstname_from_list tl
in	
let get_lastname = fun t -> match t with <lastname>@_$l -> scan_pc "" l in
let get_street = fun t -> match t with <street>@_$l -> scan_pc "" l in
let get_city = fun t -> match t with <city>@_$l -> scan_pc "" l in
let get_state = fun t -> match t with <state>@_$l -> scan_pc "" l in
let get_zip = fun t -> match t with <zip>@_$l -> scan_pc "" l in
let rec f1 = fun buftlist -> fun ts ->
  match ts with
      hd::tl1 -> 
	begin
	  match hd with
	      <row>@_$t1 ->
		begin
		  match t1 with
		      id::tl ->
			let id_pc = get_id id in
			  if (int_of_string id_pc) mod 2 = 0 then
			    match tl with firstname::tl -> (* firstname::<lastname>@_[lastnames]:: .... *)
			      let firstname_pc = get_firstname firstname in
				match tl with lastname::tl ->
				  let lastname_pc = get_lastname lastname in
				    match tl with street::tl ->
				      let street_pc = get_street street in
					match tl with city::tl ->
					  let city_pc = get_city city in
					    match tl with state::tl ->
					      let state_pc = get_state state in
						match tl with zip::tl ->
						  let zip_pc = get_zip zip in
						    match tl with [] ->
						      f1
							(((<row>@{}$
							     ((<id>@{}$((PC id_pc)::[])) ::
								(<firstname>@{}$((PC firstname_pc)::[])) ::
								(<lastname>@{}$((PC lastname_pc)::[])) ::
							      (<street>@{}$((PC street_pc)::[])) ::
								(<city>@{}$((PC city_pc)::[])) ::
								(<state>@{}$((PC state_pc)::[])) ::
								(<zip>@{}$((PC zip_pc)::[])) :: [])))::
							   buftlist)
							tl1
			  else
			    match tl with firstname::tl ->
			      0 #
				match tl with lastname::tl ->
				  0 #
				    match tl with street::tl ->
				      0 #
					match tl with city::tl ->
					  0 #
					    match tl with state::tl ->
					      0 #
						match tl with zip::tl ->
						  0 #
						    match tl with
							[] -> f1 buftlist tl1
		end
	end
    | [] -> buftlist
in
let rec f = fun t ->
  match t with
      <table>@_$ts -> 
	let buftlist = f1 [] ts in
	  print_list (sort (fun x -> (fun y -> lessthan (get_firstname_buf x) (get_firstname_buf y))) buftlist)
in
  f
