let rec get_firstname = fun tl ->
  match tl with
      hd::tl -> 
	(match hd with
	     (<first>@a$first_tl) -> first_tl
	   | _ -> get_firstname tl)
in
let rec get_lastname = fun tl -> 
  match tl with 
      (<lastname>@_$last_tl)::tl ->
	last_tl (* value_of last_tl *)
    | hd::tl ->
	get_lastname tl
in
let rec get_first_last = fun tl ->
  match tl with
      <firstname>@_$first_tl::tl ->
	(<first>@_$first_tl)::(get_lastname tl)
    | hd::tl -> get_first_last tl
in
let rec process_row = fun tl ->
  match tl with
      (<row>@_$row_tl)::tl ->
	(<row>@_$(get_first_last row_tl))::(process_row tl)
    | hd::tl ->
	process_row tl
    | [] -> []
in
let rec process_table = fun tl ->
  match tl with
      <table>@_$table_tl ->
	<document>@{}$(process_row table_tl)
in
  process_table

