
{
(* Ūѿؿʤɤ *)
open RuntimeType
(* open Type *)
}

(* ɽά *)

(*
let space = [' ' '\t' '\n' '\r']
let digit = ['0'-'9']
let lower = ['a'-'z' '_']
let upper = ['A'-'Z']
*)

let space = [' ' '\t' '\n' '\r']
let char = ['A'-'Z' 'a'-'z' '0'-'9' '.']
let char_and_space = ['A'-'Z' 'a'-'z' '0'-'9' ' ' '\t' '\n' '\r' '.']

rule token = parse
(*
| space+
    { token lexbuf }
*)
| "<!--"
    { comment lexbuf; (* ͥȤȤΤΥȥå *)
      token lexbuf }
| "<" char+
    {
      let label = Lexing.lexeme lexbuf in
      (* let _ = print_string "OK1\n"; print_string label; flush stdout in *)
      let label = String.sub label 1 ((String.length label) - 1) in
      let attr = search_end lexbuf in
	StartTag(label, attr)
    }
| "</" char+
    {
      let label = Lexing.lexeme lexbuf in
	(* let _ = print_string "OK2\n"; print_string label; flush stdout in *)
      let label = String.sub label 2 ((String.length label) - 2) in
      let _ = search_end lexbuf in
	EndTag(label)
    }
| char_and_space+
    { 
      (* let _ = print_string "OK3\n" in *)
	Pcdata(Lexing.lexeme lexbuf)
    }
| eof
    { Eof }
| _
    { Format.eprintf "unknown token %s near characters %d-%d@."
	(Lexing.lexeme lexbuf)
	(Lexing.lexeme_start lexbuf)
	(Lexing.lexeme_end lexbuf);
      failwith "lex error" }
and comment = parse
| "-->"
    { () }
(*
| "(*"
    { comment lexbuf;
      comment lexbuf }
*)
| eof
    { failwith "unterminated comment" }
| _
    { comment lexbuf }
and search_end = parse
| space+
    { search_end lexbuf }
| '>'
    { [] }
| char+
    { let key = Lexing.lexeme lexbuf in
      (* let _ = print_string "OKr\n"; print_string key; flush stdout in *)
      (* let _ = print_string (key^"\n"); flush stdout in *)
      let _ = search_end' lexbuf in
      let value = search_end'' lexbuf in
      (* let _ = print_string (value^"\n"); flush stdout in*)
      let tl = search_end lexbuf in
	(key, value)::tl }
| _
    { Format.eprintf "unknown token %s near characters %d-%d@."
	(Lexing.lexeme lexbuf)
	(Lexing.lexeme_start lexbuf)
	(Lexing.lexeme_end lexbuf);
      failwith "lex error" }
and search_end' = parse
| space+
    { search_end' lexbuf }
| '='
     { () }
| _
    { Format.eprintf "unknown token %s near characters %d-%d@."
	(Lexing.lexeme lexbuf)
	(Lexing.lexeme_start lexbuf)
	(Lexing.lexeme_end lexbuf);
      failwith "lex error" }
and search_end'' = parse
| space+
    { search_end'' lexbuf }
| '\"' char_and_space+ '\"'
    { Lexing.lexeme lexbuf }
| char+
    { Lexing.lexeme lexbuf }
| _
    { Format.eprintf "unknown token %s near characters %d-%d@."
	(Lexing.lexeme lexbuf)
	(Lexing.lexeme_start lexbuf)
	(Lexing.lexeme_end lexbuf);
      failwith "lex error" }
